package org.gcube.application.geoportal.service.engine;

import org.gcube.application.geoportal.managers.AbstractRecordManager;
import org.gcube.application.geoportal.service.engine.mongo.MongoClientProvider;

import lombok.Getter;
import lombok.Setter;
import lombok.Synchronized;

public class ImplementationProvider {

	private static ImplementationProvider instance=null;
	
	@Synchronized
	public static ImplementationProvider get() {
		if(instance==null) {
			instance=new ImplementationProvider();
		}
		return instance;
	}
	
	
	@Getter
	@Setter
	private MongoClientProvider mongoClientProvider=null;
	
	public void shutdown() {
		// Stop JPA
		AbstractRecordManager.shutdown();
		mongoClientProvider.shustdown();
	}
	
	public void startup() {
		mongoClientProvider.init();
	}
}
