package org.gcube.application.geoportal.service.engine.mongo;

import java.util.Arrays;

import org.gcube.application.geoportal.model.fault.ConfigurationException;
import org.gcube.application.geoportal.service.ServiceConstants;
import org.gcube.application.geoportal.service.model.internal.db.MongoConnection;
import org.gcube.application.geoportal.service.utils.ISUtils;

import com.mongodb.MongoClient;
import com.mongodb.MongoClientOptions;
import com.mongodb.MongoCredential;
import com.mongodb.ServerAddress;

import lombok.Synchronized;

public class DefaultMongoProvider implements MongoClientProvider {

	public DefaultMongoProvider() {
		// TODO Auto-generated constructor stub
	}

	@Override
	public void init() {
        
	}

	@Override
	public void shustdown() {
		// TODO Auto-generated method stub

	}

	
	private static MongoClient instance=null;
	@Override
	@Synchronized
	public MongoClient getClient() throws ConfigurationException{
		if(instance==null) {
			MongoConnection conn= ISUtils.queryForMongoDB(ServiceConstants.MONGO_SE_PLATFORM, ServiceConstants.MONGO_SE_GNA_FLAG);
			
			
			MongoCredential credential = MongoCredential.createCredential(conn.getUser(), conn.getDatabase(), 
					conn.getPassword().toCharArray());

			 MongoClientOptions options = MongoClientOptions.builder().sslEnabled(true).build();

			 instance = new MongoClient(new ServerAddress(conn.getHosts().get(0),conn.getPort()),
			                                           credential,
			                                           options);
		}
		
		return instance;
	}

}
